{
// LOCATIONS.JSX VERSION 0.1.1 DEBUG
// Copyright (c) 2012 
// Fabian "fabiantheblind" Morón Zirfas  
// Permission is hereby granted, free of charge, to any 
// person obtaining a copy of this software and associated
// documentation files (the "Software"), to deal in the Software
// without restriction, including without limitation the rights 
// to use, copy and modify copies of the Software, and to  permit persons to 
// whom the Software is furnished to do so, subject to 
// the following conditions:  
// The above copyright notice and this permission notice
// shall be included in all copies or substantial portions of the Software.  
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF  CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTIO
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.  

// see also http://www.opensource.org/licenses/mit-license.php

// ------------------------
run_script(this);
// ------------------------


function run_script(thisObj){

alert("This is a DEBUG version 0.1.1\nfor this problem http://aescripts.com/forums/discussion/comment/702\n\nGet a release version 0.1 @\nhttp://aescripts.com/locations");

/**
 * Check if license already was accepted
 * and save it
 */
var res = null;
var website = "http://fabiantheblind.github.com/locations";
var settingsSectionName = "locations";
if((app.settings.haveSetting(settingsSectionName,"licaccept") == true)){
var licres = parseInt(app.settings.getSetting(settingsSectionName,"licaccept"));
if (licres==1){
    res = [true,true];
} else {
    res = licenseDiag("Locations",website);
    };
}else{
  res = licenseDiag("Locations",website);
};
if (!res[1]){
    return;
}if(res[0]){
    app.settings.saveSetting(settingsSectionName,"licaccept",1);
};

/**
 * the global object
 * @type {Object}
 */
var locdata = new Object();
locdata.basicPointMarker = null;
locdata.version = 0.11;
locdata.website = website;
locdata.settings = {
    /**
     * defines what kind of layer will be used as marker
     * 0 --> nothing
     * 1 --> nullObject
     * 2 --> LightLayer
     * 3 --> TextLayer
     * 4 --> SolidLayer
     * 5 --> Marker Precomp
     * @type {Number}
     */
    markerType : 1,
    /**
     * defines if 2D or 3D
     * 0 is 2D
     * 1 is 3D
     * @type {Number}
     */
    dimensions : 0,
    imports:0,
    importedtextcolumn:null,
    layerprefix:"loc ",
    separator: ",",
    nameprefix: "",
    namesuffix: "",
    bake : false,
    radius : 250,
    basicPointMarkerName : "loc basicMarker",
    bMarkerWidth : 25,
    bMarkerHeight : 25,
    bMarkerAspectRatio : 1,
    bMarkerDur :10,
    bMarkerfps :25,
    bMarkerStrokeColor : [1,1,1],
    bMarkerFillColor : [0,0,0],
    bMarkerFillTint : 75
};
locdata.rawdata = null;
locdata.textLines = null;
locdata.markers = [];
locdata.helpText = "Locations.jsx is a AE CS4+ script for creating geolocated markers on an equrectangular map.\n\n"+
"1. 3D Checkbox:\n"+
"If you enable the 3D option the markers you create will be created using cartesian coordiantes. Taht allows you to place them on a sphere. These markers are bound to an center layer that has aslider for the radius of that sphere. If this is unchecked your comp needs to be in an 2:1 ratio.\n\n"+
"2. bake Checkbox:\n"+
"If you enable this the script will use the AE positions. The expression that calculates the position based on lat lon is still there but disabled.\n\n"+
"3. ? Button:\n"+
"Opens the help. Duh.\n\n"+
"4. Read Locations Button:\n"+
"This button opens a file chooser dialoge. Select an .tsv or .csv file. The Script only can handle tab or comma separeted values. It will parse the content of the file and try to fill your latitude, longitude and text dropdown.\n\n"+
"5. Marker Type Dropdown:\n"+
"     * 0 --> nothing\n"+
"     * 1 --> nullObject\n"+
"     * 2 --> LightLayer\n"+
"     * 3 --> TextLayer\n"+
"     * 4 --> SolidLayer\n"+
"     * 5 --> Marker Precomp\n"+
"There are diffrent type of markers. LightLayers will be handeled diffrent than the rest due to the fact that lights can't have effects. So the script will calculate the real position and not, like the rest, add 2 angle controllers that can be used to change the lat long degrees. If you choose the Marker Precomp option the script will create a tiny comp that will be used as marker.\n\n"+
"6. Lat Dropdown:\n"+
"Select the latitude row of your csv after reading it in.\n\n"+
"7. Lon Dropdown:\n"+
"Select the longitude row of your csv after reading it in.\n\n"+
"8. Txt Dropdown:\n"+
"Select the row that should be used as text. This text will always be the layername and if you use textlayers it also will be its content.\n\n"+
"9. Build Locations Button:\n"+
"This will create your markers.\n\n"+
"For more info visit "+ website;


var errorStrings;
var uiStrings = new Object();

// marker type pulldown content
// 
uiStrings.markerType = ["none","Null Object","Light Layer","Text Layer","Solid","Marker Precomp"];



///   THIS WILL CHECK IF PANEL IS DOCKABLE OR FLAOTING WINDOW  
var win   = buildUI(thisObj , locdata ,errorStrings, uiStrings);
if ((win != null) && (win instanceof Window)) {
    win.center();
    win.show();
}; // end if win  null and not a instance of window 

};// close run_script


/**
 * This builds the UI
 * @param  {the script} thisObj      
 * @param  {global object} locdata holds all the data
 * @param  {gloglobal object} errorStrings Holds Error messages
 * @param  {global object} uiStrings    Holds Strings for the UI
 * @return {Window}              The result is the Panel
 */
function buildUI (thisObj , locdata ,errorStrings, uiStrings) {

var script_file = File($.fileName); // get the location of the scriptfile
var script_file_path = script_file.path; // get the path

// this is the icon for the settings
var myBinary = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x0F\x00\x00\x00\x0F\b\x06\x00\x00\x00;\u00D6\u0095J\x00\x00\x02\u00ADIDAT(Se\u0093MH\u00DAq\x18\u00C7\x1F6\u00DA\u00A5\u00C1v\u00D8\u00D8ets\u0087\b%c\rd\f,\u00B2\x0E\u0091\u00B0`\u00DB%\x18\u00B4\u00CB\x1A\u0083RL\r\u00B5\u00D4\u00C4\x15\u00EB0_\u00CAB0\x0Fk\x11\"*LD)\n\u0083$t*3\u00E9\x05\u009A\x0B\u0099\u00D8<\b\u00B1([\u00FE\u00F6<\x7FP\u008A\x1D\x1E\u00FEo\u00CF\u00F7\u00F9}\u009E\u00EF\u00F3\u00FC\u00811\x06\x14\u00B1X\f\u00BA\u00BA\u00BAnttt<t\u00B9\\\u00D0\u00D3\u00D3s\u00AF\u00B5\u00B5\u00B5\u00BA\u00B8\u00B8\u00A8\u00F6x< \u0097\u00CB\x1B\u00F7\u00F7\u00F7o\u00D7\u00F2)\u00EA7\u00AB\u00AB\u00AB \x12\u0089\u00DE\u00F7\u00F7\u00F7\u00FF\u00EC\u00EB\u00EB{-\x10\b>\u008D\u008E\u008E2\u009DN\u00F7\r\x0B\u00BElkk\u00FB:99\x199;;\u00BBU\x17oll\u00C0\u00C2\u00C2\x02\u0098L&\u0090J\u00A5\u00EF&&&\u0098Z\u00ADfZ\u00AD\u0096\u00D9l66==\u00CDFFF\x18\nY \x10\u00D8\u00BEv2\u009E\u00D4\u00C0\u00E3\u00F1\u0094|>_\u00D3\u00D9\u00D9\u00F9}ff\u0086\u00CD\u00CE\u00CE\u00D6\u0083\n8\x1C\x0E677G\x14'\u00E3\u00E3\u00E3Z,\u00A6\u00C5\x16\u009A@\u00A3\u00D1<\u00C0\u0087\u009C\u00C1``$\u00B4X,lee\u0085\u00A5R\u00A9\u00C3\u00BD\u00BD=_(\x14\u008AY\u00ADVf\u00B7\u00DB\x19]\u0095J%w\u00CDf\u00B3/ \u0091H\x00b>'LJX^^f\u0085B\u00C1}yyy\u0097\u00D0\u00B0G\u00C0\x02\u0083f\u00B3\u00B9B\x14D\u00B0\u00B5\u00B5\u00E5\u00E5\u00B0\u00DB\u00DB\u00DB\u0085---\x0E\u00EA\u00950\u00D7\u00D7\u00D7\x7F\u009C\u009F\u009F7^\u00ED\u00ED\u00E8\u00E8\b\u0086\u0087\u0087\u009DDF\u00A7\u00A2\x0F\u00A9`0(\u00A0\u00F1\u00D4\u00CD!d\x14{\u00AE\n)2\u0099\fy\u00F3\u008A\u00F2\u00A8\u00FF\u00A9\u00A9)\u00A6P(\x18`oo\u0097\u0096\u00966k\u00FDb\u00E58\u009A\x01\x17\x17\x17\u009C\u00B0R\u00A9\u0080\u00D1h\x044T\u00A7\u00D7\u00EB9:\u00DC\u0089R\u00B9\\\u00FE\x00\u0091H\x04\x06\x06\x06zU*\x15W\x15\x13\u00ABx\u00C2 \x16\x04D\u0083\u00B1\u00B11\u00C0ey\u00D4\u00DD\u00DD\u00FD\u008B\u00E8\u00C8\u0097p8\u00EC\u00E6z\x16\u008B\u00C5\u00F7\u0085B\u00E1&\u00A1\u0090\x19\u00F4Q&\u0093\u00FD\u00C5\u00B1\u00B9\u00F0\u00FD\u009B\u00E6\u00E6f\u00BDD\")\u00D0\u00BCIL\u0081\x13\u00FA\u00BD\u00BB\u00BB\u00FB\x18\u009CN\u00E7\x1Dt8\u0080\u00F8!D\u00FAS\u00ABN\u00C9\u00B4,8W\u00CE$z\u00EF\u00F7\u00FBY2\u0099\u00DC\u008EF\u00A3\u00D9b\u00B1(\u00E2z\"\u0084R\u00A9\x04CCCHmd\u00B8q\u00F5\u00C5\u00A0\u0098\u009F\u009F\u00E7\u00C4kkkQ\u00CCm\u00A8V\u00AB7\u00AF\u00ED6\u00AE\x1E \u00DEG\u00AF\u00D7\u00CB\x0E\x0E\x0E>\u00BB\u00DD\u00EE\x14\u0099\x18\u008F\u00C7\u008B\u00E9t\u00FA\x0B\u008AO|>_\u0092\u00E6\u00FE\u00DF\u008Fq||\f\u00B9\\\u00AE\t\tz\u00E9\x19Q\u009F\u0090\u00B3\u00F9|^\u0081\x0B\x03;;;\u00CFNOO\u009F\u00E2\u00A9u\u00CD?}g/\u00CF\u0086w\x15k\x00\x00\x00\x00IEND\u00AEB`\u0082";

//create a temporary image file before displaying it.
var icon = File(script_file_path + "/xxxiconxxx.png");

 icon.encoding = "BINARY";
 icon.open( "w" );
 icon.write( myBinary );
 icon.close();


var win = (thisObj instanceof Panel) ? thisObj : new Window('palette', 'Locations',[0,0,150,260],{resizeable: true}); 

if (win != null) {
    var H = 25;
    var W1 = 40;
    var G = 10;
    var x = G;
    var y = G;
    var yuioff = G/2;

    win.threedee_check = win.add('checkbox', [x,y,x + W1, y + H], '3D');
    win.threedee_check.value = false;
    // x+= W1 + G;
    win.bake_check = win.add('checkbox', [x + W1*0.8+G,y,x + W1*2+G, y + H], 'Bake');
    win.bake_check.value = locdata.settings.bake;

 if(icon.exists == true){
    win.settings_button = win.add("iconbutton",  [x + W1*2+G,y,x + W1*3,y + H], icon); //displaying it.
    icon.remove(); // dont need the icon any more as file
    }else{
    win.settings_button = win.add('button', [x + W1*2+G,y,x + W1*3,y + H], '*'); //displaying it.

    }

    // win.settings_button = win.add('button', [x + W1*2+G,y,x + W1*3,y + H], '*'); 
 
    win.help_button = win.add('button',[x + W1*3+G,y,x + W1*4,y + H], '?');

    x=G;// reset x to gutter width
    y+= (H + (G/2)); // increase y
    win.read_button = win.add('button', [x,y,x + W1*4, y + H], 'Read Locations'); 
    x=G;// reset x to gutter width
    y+= (H + (G/2)); // increase y
    win.type_stxt = win.add('statictext', [x ,y + yuioff,x+W1,y+H], 'Type:');// the label lat
    win.type_stxt.justify = 'left'; 

    win.markerType_ddl = win.add('dropdownlist', [x+W1+G,y,x + W1*4,y + H], uiStrings.markerType);
    win.markerType_ddl.selection = locdata.settings.markerType;
    x=G;// reset x to gutter width
    y+= (H + (G/2)); // increase y
    win.lat_stxt = win.add('statictext', [x ,y + yuioff,x+W1,y+H], 'Lat:');// the label lat
    win.lat_stxt.justify = 'left'; 
    win.lat_ddl = win.add('dropdownlist', [x+W1+G,y,x+W1*4,y + H], ["none"]);// the dropdown lat

    x=G;// reset x to gutter width
    y+= (H + (G/2)); // increase y
    win.lon_stxt = win.add('statictext', [x ,y + yuioff,x+W1,y+H], 'Lon:');// the label lon
    win.lon_stxt.justify = 'left'; 
    win.lon_ddl = win.add('dropdownlist', [x+W1+G,y,x+W1*4,y + H], ["none"]);// the dropdown lon
    x=G;// reset x to gutter width
    y+= (H + (G/2)); // increase y
    win.txt_stxt = win.add('statictext', [x ,y + yuioff,x+W1,y+H], 'Name:');// the label txt
    win.txt_stxt.justify = 'left';
    win.txt_ddl = win.add('dropdownlist', [x+W1+G,y,x+W1*4,y + H], ["none"]);// the dropdown txt
    x=G;// reset x to gutter width
    y+= (H + (G/2)); // increase y

    win.build_button = win.add('button', [x,y,x+W1*4,y + H], 'Build Locations'); 


    // ------------ the ui functions ------------

    /**
     * this is the 3D checkbox
     * sets
     * locdata.settings.dimensions to 0 or 1
     */
    win.threedee_check.onClick = function (){
        if(this.value == true){
            locdata.settings.dimensions = 1;
         if(win.markerType_ddl.selection.index == 2){
            var temp_radius = set_radius(locdata.settings.radius);
            locdata.settings.radius = temp_radius;
        };
        }else if(this.value == false){
            locdata.settings.dimensions = 0;
        }
    };

    win.bake_check.onClick = function () {
        locdata.settings.bake = this.value;
        if((this.value == true)&&(locdata.settings.dimensions == 1)){
            var temp_radius = set_radius(locdata.settings.radius);

            locdata.settings.radius = temp_radius;
        }
    };
    /**
     * reads in the CSV / TSV data
     * fills:
     * locdata.textLines
     * locdata.rawdata
     * win.lat_ddl
     * win.lon_ddl
     * win.txt_ddl
     * 
     */
    win.read_button.onClick = function () {
        // alert(this.text);
        locdata.textLines = read_in_txt();

        if(locdata.textLines != null){
            // locdata.markers = lines_to_markers(locdata.textLines);
            var res = textlines_to_data(locdata.textLines,locdata.settings.separator);
            // alert(res.toSource());
            locdata.rawdata = res;
            // reading the textlines worked if it wasnt null
 if(locdata.rawdata != null){

                win.lat_ddl.removeAll();// remove the content of the ddl
                win.lon_ddl.removeAll();// remove the content of the ddl
                win.txt_ddl.removeAll();// remove the content of the ddl
                var debugstrings = [];
for(var i = 0;i < locdata.rawdata.keys.length;i++){

debugstrings.push("locdata.rawdata.keys item "
            +String(i) +" is type: "
            + locdata.rawdata.keys[i].constructor.name
            );

    win.lat_ddl.add('item',locdata.rawdata.keys[i]);
    win.lon_ddl.add('item',locdata.rawdata.keys[i]);
    win.txt_ddl.add('item',locdata.rawdata.keys[i]);

    // occurs on AECS611.0.2.11 / Win7 SP1
    // HERE is a bug! http://aescripts.com/forums/discussion/comment/702
    // content of locdata.rawdata.keys[j] seems to be not a string
    for(var j = 0; j < locdata.rawdata.keys.length;j++){

        try{
            var reslat = locdata.rawdata.keys[j].search(/lat/i) != -1 ? true : false;
            if (reslat == true) {
                win.lat_ddl.selection = j;
                };// end if

            }catch(e){
           debugstrings.push("Loop J item: " + String(j));
           debugstrings.push("I(all): "+ i + " J(lat): "+ j + " K(lon): "+ k + " L(txt): " + l );
           debugstrings.push(e.toString());
            };// end of catch in J loop

            };// end of J loop


    for(var k = 0; k < locdata.rawdata.keys.length;k++){
        try{
        var reslon = locdata.rawdata.keys[k].search(/lon/i) != -1 ? true : false;
        if (reslon == true) {
            win.lon_ddl.selection = k;
            };// end if
        }catch(e){
            debugstrings.push("Loop K item: " + String(k));
            debugstrings.push("I(all): "+ i + " J(lat): "+ j + " K(lon): "+ k + " L(txt): " + l );
            debugstrings.push(e.toString());
            };// end of catch in K loop
        };// end of K loop

        for(var l = 0; l < locdata.rawdata.keys.length;l++){
        try{
        var restxt = locdata.rawdata.keys[l].search(/name/i) != -1 ? true : false;
        if (restxt == true) {
            win.txt_ddl.selection = l;
            };// end if
        }catch(e){
            debugstrings.push("Loop L item: " + String(l));
            debugstrings.push("I(all): "+ i + " J(lat): "+ j + " K(lon): "+ k + " L(txt): " + l );
            debugstrings.push(e.toString());
            };// end of catch in L loop
        };// end of L loop

        };// end of I loop
// get the debug info
    alert("DEBUGINFO: \n"+debugstrings.join("\n"));
    }; // end of locdata.rawdata != null
}else{
     alert("There was an Error in your locations file");
};// end of else locdata.textLines != null
};// end of on click


    win.txt_ddl.onChange = function () {

       locdata.settings.importedtextcolumn = this.selection.index;

    }
    win.markerType_ddl.onChange = function () {
        locdata.settings.markerType = this.selection.index;
        // alert(locdata.settings.markerType);
        if((this.selection.index == 2)&&(locdata.settings.dimensions == 1)){
            var temp_radius = set_radius(locdata.settings.radius);
            locdata.settings.radius = temp_radius;
        };
    };


    win.build_button.onClick = function () {
    var noval = false;
    locdata.markers = new Array();
    // we need to loop like this so we
    // have an associative array
    // 
    
    if(locdata.rawdata == null){

        alert("You have no data yet.");
        return;
    }
    if(locdata.rawdata.hasOwnProperty("fields")){
    for(var i in locdata.rawdata.fields){

        var f_lat = "0";
        var f_lon = "0";
        var f_txt = "locations";
        for(var j in locdata.rawdata.fields[i]){
            if(win.lat_ddl.selection != null){
                f_lat = locdata.rawdata.fields[i]["field_" + String(win.lat_ddl.selection.index)];
            };// end if lat check
            if(win.lon_ddl.selection != null){
                f_lon = locdata.rawdata.fields[i]["field_" + String(win.lon_ddl.selection.index)];
            };// end if lon check
            if(win.txt_ddl.selection != null){
                f_txt = locdata.rawdata.fields[i]["field_" + String(win.txt_ddl.selection.index)];
            };// end if txt check

        }
    //if there was still an error with the values
    //we reset them to 0
    f_lat = resetValIfNAN(parseFloat(f_lat),0.0,"Your latitude value seems to be NAN (not a number)");
    f_lon = resetValIfNAN(parseFloat(f_lon),0.0,"Your longitude value seems to be NAN (not a number)");

     var marker = {
            lat   : parseFloat(f_lat),
            lon   : parseFloat(f_lon),
            name  : String(f_txt)
        };
    // if(i == 0 ) alert(locdata.rawdata.fields[i]);
    // 
    locdata.markers.push(marker);
    }; // end of i loop

    //alert(locdata.markers.toSource());
    // return;

    if(locdata.markers != null){
            locdata.settings.imports++;
            main_script(locdata);
        }else{
        alert("you have no markers");
        };// end if if locdata markers != null
    };// end of hasOwnProperty fields
    }; 

    win.settings_button.onClick = function  () {
        settings_dialoge(locdata,"Settings",win);
    };
    win.help_button.onClick = function () {
        helpDialog(locdata.helpText , "Locations.jsx " +locdata.version + "");
    }; 
    }
return win
};// end buildUI


function settings_dialoge (locdata,title,win) {

var use_komma = (locdata.settings.separator.search(/,/i) != -1) ? true : false;
var nameprefix = locdata.settings.nameprefix;
var namesuffix = locdata.settings.namesuffix;
var layerprefix = locdata.settings.layerprefix;

var diag                     = new Window ('dialog',title + ''); // the new window
    diag.preferredSize       =    {'width':250,'height':130};
    diag.supergroup                 = diag.add('group',undefined,'');
    diag.supergroup.orientation     ='column';

diag.rowcsv = diag.supergroup.add('group');
diag.rowcsv.orientation = 'row';
diag.rowcsv.alignment = 'left';
diag.rowcsv.headline = diag.rowcsv.add('statictext',undefined,'CSV Delimiter:');
diag.rowcsv.tab_check = diag.rowcsv.add('checkbox',undefined,'TAB');
diag.rowcsv.tab_check.value = false;
diag.rowcsv.komma_check = diag.rowcsv.add('checkbox',undefined,'COMMA');
diag.rowcsv.komma_check.value = true;

diag.rowtxt = diag.supergroup.add('group');
diag.rowtxt.orientation = 'row';
diag.rowtxt.alignment = 'left';
diag.rowtxt.headline = diag.rowtxt.add('statictext',undefined,'Name Field Settings:');
diag.rowtxt.stxt_prefix = diag.rowtxt.add('statictext',undefined,'Text Prefix:');
diag.rowtxt.etxt_prefix = diag.rowtxt.add('edittext',undefined,nameprefix);

diag.rowtxt.stxt_suffix = diag.rowtxt.add('statictext',undefined,'Text Suffix:');
diag.rowtxt.etxt_suffix = diag.rowtxt.add('edittext',undefined,namesuffix);

diag.rowlayer = diag.supergroup.add('group');
diag.rowlayer.orientation = 'row';
diag.rowlayer.alignment = 'left';
diag.rowlayer.headline = diag.rowlayer.add('statictext',undefined,'Layer Settings:');
diag.rowlayer.stxt_prefix = diag.rowlayer.add('statictext',undefined,'Name Prefix:');
diag.rowlayer.etxt_prefix = diag.rowlayer.add('edittext',undefined,layerprefix);

/* ----------------------------------------------- */
    diag.rowconfirm            = diag.supergroup.add ('group');
    diag.rowconfirm.orientation = 'row';
    diag.rowconfirm.alignment   = 'right';

// ------------ the comfirm or cancel buttons ------------
    diag.rowconfirm.ok               = diag.rowconfirm.add ('button', undefined, 'OK');
    diag.rowconfirm.cancel           = diag.rowconfirm.add ('button', undefined, 'Cancel');


diag.rowcsv.tab_check.onClick = function () {

if(this.value == true){
diag.rowcsv.komma_check.value = false;
use_komma = true;
}else{
diag.rowcsv.komma_check.value = true;
use_komma = false;
}
};
diag.rowcsv.komma_check.onClick = function () {

if(this.value == true){
diag.rowcsv.tab_check.value = false;
use_komma = true;
}else{
diag.rowcsv.tab_check.value = true;
use_komma = false;
}


};
diag.rowtxt.etxt_prefix.onChange = function () {
nameprefix = this.text;

};
diag.rowtxt.etxt_suffix.onChange = function () {
namesuffix = this.text;

};
diag.rowlayer.etxt_prefix.onChange = function () {
layerprefix = this.text;
};


   if (diag.show () == 1){

locdata.settings.separator = (use_komma == true) ? ",":"\t";
locdata.settings.nameprefix = nameprefix;
locdata.settings.namesuffix = namesuffix;
locdata.settings.layerprefix = layerprefix;
    return true;
  }else{  
    return false;

  };
};

function resetValIfNAN(val,resetVal, theErrorMessage){
    if(isNaN (val)==true){
    val = resetVal;
    alert(theErrorMessage);
    };
  return val;
};


function set_radius(radius){
     var temp_res = prompt("Please enter a radius",String(radius),"");
    var temp_radius = resetValIfNAN(parseFloat(temp_res),radius,"This is not a number. Reset to " + radius);
    return temp_radius;
}

/**
 * this reads in a file 
 * line by line
 * @return {Array of String}
 */
function read_in_txt(){
        
  var textFile = File.openDialog("Select a text file to import.", "*.*",false);

    if (textFile != null) {
        var textLines = new Array();
        textFile.open("r", "TEXT", "????");
        while (!textFile.eof){
            textLines[textLines.length] = textFile.readln();  
        }
        textFile.close();   
    }

    if(!textLines){
        alert("ERROR Reading file");
        return null;
    }else{

    return textLines;
    }
};

/**
 * gets lines of strings and creates the data we need from
 * CSV Header and content
 * @param  {Array of String} textLines are , or \t separeted values
 * @return {Object} 
 */
function textlines_to_data(textLines,separator){

    var data = new Object();
    data.fields = new Array();

    data.keys = [];
    // var res = CSVToArray(textLines,",");
    // alert(res);
    for(var i = 0; i < textLines.length;i++){
    
        //var line_arr = split_textline(textLines[i]);
        var line_arr = split_csv(separator,textLines[i]);
        // alert(line_arr);
    if(i == 0){
        for(var j = 0; j < line_arr.length;j++){
        data.keys[j] = line_arr[j];
        }
        // data.keys[0] = line_arr[0];
        // data.keys[1] = line_arr[1];
        // data.keys[2] = line_arr[2];

        }else{
             var obj_str = "";
            for(var k = 0; k < line_arr.length;k++){
                if(k != line_arr.length -1){
                    obj_str += 'field_' + k + ':"' + line_arr[k] + '",';
                }else{
                    obj_str += 'field_' + k + ':"' + line_arr[k] + '"';
                }
            }

        data.fields.push(eval("({"+ obj_str+"})"));
        }
    }
 return data;
};

function split_textline(line){
    // var arr = line.split("\t");
    var arr = line.split(/[,\t]/);

return arr;
};


/**
 * This is a string prototype function
 * found here http://www.greywyvern.com/?post=258
 * @param  {String} sep is the separator we use only ,
 * @return {Array}     returns an Array of strings
 */
// String.prototype.splitCSV = function(sep) {
//   for (var foo = this.split(sep = sep || ","), x = foo.length - 1, tl; x >= 0; x--) {
//     if (foo[x].replace(/"\s+$/, '"').charAt(foo[x].length - 1) == '"') {
//       if ((tl = foo[x].replace(/^\s+"/, '"')).length > 1 && tl.charAt(0) == '"') {
//         foo[x] = foo[x].replace(/^\s*"|"\s*$/g, '').replace(/""/g, '"');
//       } else if (x) {
//         foo.splice(x - 1, 2, [foo[x - 1], foo[x]].join(sep));
//       } else foo = foo.shift().split(sep).concat(foo);
//     } else foo[x].replace(/""/g, '"');
//   } return foo;
// };


// Dont use prototypes?
// 
function split_csv (sep,the_string){

for (var foo = the_string.split(sep = sep || ","), x = foo.length - 1, tl; x >= 0; x--) {
    if (foo[x].replace(/"\s+$/, '"').charAt(foo[x].length - 1) == '"') {
      if ((tl = foo[x].replace(/^\s+"/, '"')).length > 1 && tl.charAt(0) == '"') {
        foo[x] = foo[x].replace(/^\s*"|"\s*$/g, '').replace(/""/g, '"');
      } else if (x) {
        foo.splice(x - 1, 2, [foo[x - 1], foo[x]].join(sep));
      } else foo = foo.shift().split(sep).concat(foo);
    } else foo[x].replace(/""/g, '"');
  }
  return foo;
};


/*

This is the license dialoge that shows up 
on startup. If you dont tell him to go away

*/
/**
 * [licenseDiag description]
 * @param  {[type]} n       [description]
 * @param  {[type]} website [description]
 * @return {[type]}
 */
function licenseDiag (n, website) {
    var lic= "DONT USE SCRIPTS FROM UNTRUSETED SOURCES! ALWAYS DOWNLOAD THIS SCRIPT @ "+ website +"/\n\n"+
    "You have to allow the script to read and write to disk.\nso if you obtained this script from any other source then the above mentioned"+
"\nIT COULD INCLUDE MALICIOUS CODE!\nBy confirming this dialog you also accept the license agreement below\n"+    
"\nLICENSES\n"+"Copyright (c)  2012 Fabian \"fabiantheblind\" Morón Zirfas\n"+
"Permission is hereby granted, free of charge*, to any person obtaining a copy of this "+
"software and associated documentation files (the \"Software\"), to deal in the Software "+ 
"without restriction, including without limitation the rights to use, copy, modify "+ 
"the Software, and to permit persons to whom the Software is furnished to do so, subject to the following "+
"conditions:\n"+
"The above copyright notice and this permission notice shall be included in all copies "+ 
"or substantial portions of the Software.\n"+
"THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, "+ 
"INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A "+ 
"PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT "+ 
"HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF "+ 
"CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE "+
"OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n"+
"see also http://www.opensource.org/licenses/mit-license.php\n\n"+
"*if you want to donate something so I can buy cookies and beer\ndo it via aescripts.com\n";

var diag                = new Window ("dialog",n + " || readme and license agreement");
    diag.preferredSize  =    {"width":450,"height":450};
var pan                 = diag.add('group',undefined,'');
    pan.orientation     ='column';
var txt                 = pan.add('edittext',undefined,lic,{multiline:true,scrolling: false});
    txt.preferredSize   =    {"width":440,"height":430};
var btg                 =  pan.add ("group");
var cbg                 = btg.add ("group");
    cbg.alignment       = "left";
var cb                  = cbg.add ("checkbox", undefined, "dont warn me again");
    btg.orientation     = 'row';
    btg.alignment       = "right";
    btg.add ("button", undefined, "OK");
    btg.add ("button", undefined, "cancel");
if (diag.show () == 1){
    return [cb.value,true];
  }else{  
    return [false, false];
  };
};

function helpDialog(helpText , title ){
    var diag            = new Window ("dialog",title + "");
    diag.preferredSize  =    {"width":450,"height":450};
var pan                 = diag.add('group',undefined,'');
    pan.orientation     ='column';
var txt                 = pan.add('edittext',undefined,helpText,{multiline:true, scrolling: true});
    txt.preferredSize   =    {"width":440,"height":430};
var btg                 =  pan.add ("group");

var cbg                 = btg.add ("group");

    cbg.alignment       = "left";

// var reset_button        = cbg.add ("button", undefined, "Reset Values to default");

    btg.orientation     = 'row';
    btg.alignment       = "right";
    btg.add ("button", undefined, "OK");
    btg.add ("button", undefined, "cancel");


    if (diag.show () == 1){

    return true;

  }else{  

    return false;

  };
};



// ------------------------------------------------------------

    //  ______ _   _ _____   ____  ______ _    _ _____ 
    // |  ____| \ | |  __ \ / __ \|  ____| |  | |_   _|
    // | |__  |  \| | |  | | |  | | |__  | |  | | | |  
    // |  __| | . ` | |  | | |  | |  __| | |  | | | |  
    // | |____| |\  | |__| | |__| | |    | |__| |_| |_ 
    // |______|_| \_|_____/ \____/|_|     \____/|_____|


// ------------------------------------------------------------

function main_script(locdata){


app.beginUndoGroup("build lat lon marker");


var curComp = app.project.activeItem;
if (!curComp || !(curComp instanceof CompItem)){
    alert("noComp");
    return;
};

/**
 * this is in 3d mode
 */
if(locdata.settings.dimensions == 1){
    if ((curComp.selectedLayers.length > 1)){
        alert("Please select only one center layer");
    return;
    };
    var center = null;

    if ((curComp.selectedLayers.length < 1)||(curComp.selectedLayers[0] instanceof LightLayer) ||(curComp.selectedLayers[0] instanceof CameraLayer)) {
        // no center layer selected
        // this layer shoud hold the radius slider
        center = curComp.layers.addNull();
        center.name = "center "+ Number(new Date());
        center.threeDLayer = true;
        center.transform.position.expression = "[" + curComp.width/2 + ", " + curComp.height/2 + ", 0]";
        var rad_slider = center("ADBE Effect Parade").addProperty("ADBE Slider Control");
        rad_slider.name = "radius";
        rad_slider("ADBE Slider Control-0001").setValue(locdata.settings.radius);
    } else if((curComp.selectedLayers.length == 1)){

    center = curComp.selectedLayers[0];
    if(center("ADBE Effect Parade").property("ADBE Slider Control") != null){
        var angle_ctrl = center("ADBE Effect Parade").property("ADBE Slider Control");
        angle_ctrl.name = "radius";
        angle_ctrl("ADBE Slider Control-0001").setValue(locdata.settings.radius);
    }else{
        var rad_slider = center("ADBE Effect Parade").addProperty("ADBE Slider Control");
        rad_slider.name = "radius";
        rad_slider("ADBE Slider Control-0001").setValue(locdata.settings.radius);
    }



    };// only one layer selected
}; // end of dim 1


var cw = curComp.width;
var ch = curComp.height;

// do we need this?
// i think to keep the lat lon logic we do.
// but only for 2D

if(((cw/2) != ch)&&(locdata.settings.dimensions == 0)){
    alert("your comp is not 2:1");
    return;
    };


if(locdata.settings.markerType == 5){
    build_marker(locdata, curComp.duration);
};

for (var i = 0; i < locdata.markers.length;i++){
    if(locdata.settings.dimensions == 0){
        // this is 2D

        add_marker(
            locdata.settings.layerprefix,
            locdata.settings.nameprefix,
            locdata.settings.namesuffix,
            locdata.settings.importedtextcolumn,
            locdata.settings.imports,
            i,
            locdata.markers[i].lat, 
            locdata.markers[i].lon,
            build_ex_2D(),
            null, /* this is the expression for orientation !3D only! */
            locdata.markers[i].name, 
            curComp,
            locdata.settings.markerType, 
            locdata.settings.dimensions,
            locdata.basicPointMarker,
            null, /* this is the center layer !3D only! */
            null,
            locdata.settings.bake
        );
    }else{
        // this is 3D

        add_marker(
            locdata.settings.layerprefix,
            locdata.settings.nameprefix,
            locdata.settings.namesuffix,
            locdata.settings.importedtextcolumn,
            locdata.settings.imports,
            i,
            locdata.markers[i].lat, 
            locdata.markers[i].lon,
            build_ex_pos_3d(center.name),
            build_ex_orient(center.name), /* this is the expression for orientation !3D only! */
            locdata.markers[i].name, 
            curComp,
            locdata.settings.markerType, 
            locdata.settings.dimensions,
            locdata.basicPointMarker,
            center,/* this is the center layer !3D only! */
            locdata.settings.radius,
            locdata.settings.bake
        );
    }
}
app.endUndoGroup();

};


function build_ex_2D(){

var expr = new Array();

expr.push("// calc lat lon to AE coordinates");
expr.push("var factor = thisComp.width/360;");
expr.push("var lat = effect(\"lat\")(\"ADBE Angle Control-0001\");");
expr.push("var lon = effect(\"lon\")(\"ADBE Angle Control-0001\");");
expr.push("var x = (lon) * factor+ ( thisComp.width / 2);");
expr.push("var y = (lat*-1) * factor + ( thisComp.height / 2);");
expr.push("[x,y]");


return expr.join("\n");
}

/**
 * add_marker (lat, lon ,expr, text, comp, type, dim)
 * this is a unified function to add marker
 * @param {Number} lat  latitude of the marker
 * @param {Number} lon  longitude of the marker
 * @param {String} expr the expression for the position of the marker
 * @param {String} text The text fieled of the csv 
 * @param {Composition} comp the current comp
 * @param {Number} type THere are 4 diffrent types of layers that can be created
 * @param {Number} dim  the dimension value 0 means 2D 1 menas 3D
 */

function add_marker (layerprefix,nameprefix,namesuffix, column,imports,num,lat, lon ,expr_pos,expr_orient, text, comp, type, dim, bMarker,center,radius,bake){
        
/**
* locdata.settings.dimensions
* defines if 2D or 3D
* 0 is 2D
* 1 is 3D
* @type {Number}
*/
/**
* locdata.settings.markertype
* defines what kind of layer will be used as marker
* 0 --> nothing
* 1 --> nullObject
* 2 --> LightLayer
* 3 --> TextLayer
* 4 --> SolidLayer
* @type {Number}
*/
        

if(type == 0){
    // type none
    // 
}else if(type == 1){
    /**
     * this is fpr null objects
     * @type = 1
     */
    var layer = comp.layers.addNull();
    var anchorVal = null;
    if(dim == 0){
        anchorVal = [50,50];
    }else if (dim == 1){
        layer.threeDLayer = true;
        anchorVal = [50,50,0];
    }
    layer.transform.anchorPoint.setValue(anchorVal);

}else if(type == 2){
     /**
      * this is lights
      * lights have to be handeld diffrent than the rest
      * 
      */
     
    if(dim == 0){
    var xy = calc_position_2D(lat,lon,comp);
    // var factor = comp.width/360;
    // var x = (lon) * factor+ ( comp.width / 2);
    // var y = (lat*-1) * factor + ( comp.height / 2);
    // 
    var layer = comp.layers.addLight(layerprefix + text, xy);
    layer.transform.position.setValue([xy[0],xy[1],0]);

}else if (dim == 1){
    var layer = comp.layers.addLight(layerprefix + text, [0,0]);
    var pos = calc_cartesian_position(lat,lon,radius,comp);
    layer.transform.position.setValue(pos);

};
if(text.length > 1){
    layer.name = layerprefix + text;
    }else{
    layer.name = "marker at lat: " + lat.toFixed(3)+ " lon: "+ lon.toFixed(3);
    }
    try{
        layer.lightType = LightType.POINT;
    }catch(e){
    /* works only in CS6 */
    }; // close catch
}else if(type == 3){
    /**
     * this is textlayers
     * 
     */
var layer = comp.layers.addText(nameprefix + text + namesuffix);

    }else if(type == 4){
        //addSolid(color, name, width, height, pixelAspect, duration)
        var solid_name = "";
        if(text.length > 1){
            solid_name = layerprefix + text;
        }else{
        solid_name = "marker at lat: " + lat.toFixed(3)+ " lon: "+ lon.toFixed(3);
        }
        var layer = comp.layers.addSolid([0,0,0], solid_name, 50, 50, 1, comp.duration);

    }else if((type == 5)&&(bMarker != 0)){
        var layer = comp.layers.add(bMarker);

    }


    if(type != 2){
        if(text.length > 1){
            layer.name = layerprefix + text;
        }else{
            layer.name = "marker at lat: " + lat.toFixed(3)+ " lon: "+ lon.toFixed(3);
        }; // 

    var lat_angle = layer("ADBE Effect Parade").addProperty("ADBE Angle Control");
        lat_angle.name = "lat";
        lat_angle("ADBE Angle Control-0001").setValue(lat);

    var lon_angle = layer("ADBE Effect Parade").addProperty("ADBE Angle Control");
        lon_angle.name = "lon";
        lon_angle("ADBE Angle Control-0001").setValue(lon);
     

    if(dim == 1){
        layer.threeDLayer = true;
           layer.transform.orientation.expression = build_ex_orient(center.name);
        }

        layer.transform.position.expression = expr_pos;
        if(bake == true){
            layer.transform.position.expressionEnabled = false;
        }
    if(dim == 0){
        var xy = calc_position_2D(lat,lon,comp);
        layer.transform.position.setValue(xy);
    }else if(dim == 1){
        var xyz = calc_cartesian_position(lat,lon,radius,comp);
        layer.transform.position.setValue(xyz);
    }
        
}; // end of exclude layer type 2 (lights)
layer.comment = "*"+text+
",*_locations,*csv-row "+String(num + 1)+
",*import "+String(imports)+
",*column "+String(column + 1);// this is for all layers again
};


/**
 * returns a random number
 * @return {Number}     a number
 */
function randomNum(){ return Math.floor((Math.random()*10000)); };

function build_marker (locdata, dur) {
var timestamp = String(Number(new Date()));
timestamp = timestamp.substr(timestamp.length - 6,timestamp.length -1);
    locdata.basicPointMarker = app.project.items.addComp(
        locdata.settings.basicPointMarkerName + " " + timestamp,
        locdata.settings.bMarkerWidth,
        locdata.settings.bMarkerHeight,
        locdata.settings.bMarkerAspectRatio,
        dur,
        locdata.settings.bMarkerfps
        );

    var markerLayer = locdata.basicPointMarker.layers.addShape();
    markerLayer.name = locdata.basicPointMarkerName + " Shape";
    var vectorsGroupRoot = markerLayer("ADBE Root Vectors Group");

    var vectorGroup = vectorsGroupRoot.addProperty("ADBE Vector Group");
    var vectorsGroup = vectorGroup.addProperty("ADBE Vectors Group");
    var ellipse = vectorsGroup.addProperty("ADBE Vector Shape - Ellipse");
    ellipse.property("ADBE Vector Ellipse Size").setValue([23,23]);

    var bMfill = vectorsGroup.addProperty("ADBE Vector Graphic - Fill");
    bMfill.property("ADBE Vector Fill Color").setValue(locdata.settings.bMarkerFillColor);
    bMfill.property("ADBE Vector Fill Opacity").setValue(locdata.settings.bMarkerFillTint);
    
    var bMstroke = vectorsGroup.addProperty("ADBE Vector Graphic - Stroke");
    bMstroke.property("ADBE Vector Stroke Color").setValue(locdata.settings.bMarkerStrokeColor);
    bMstroke.property("ADBE Vector Stroke Width").setValue(1);
    bMstroke.property("ADBE Vector Stroke Opacity").setValue(locdata.settings.bMarkerFillTint);
};

function calc_cartesian_position(lat,lon,radius,comp){
// var temp_lat = lat*-1;
// var temp_lon = lon*-1;
// var temp_rad = radius;
var res = calc_position(lat*-1,lon*-1,radius);
var x = res[0] + comp.width/2;
var y = res[1] + comp.height/2;
var z = res[2] *-1;

return [x,y,z];
}

function calc_position(lat, lon , radius){
 var latDegreeOffset = degreesToRadians(90) ;// in radians
 //Convert lat and lon to radians.
 lat = Math.PI * lat / 180;
 lon = Math.PI * lon / 180;
 // //Adjust lat and lon by radians.
  lat -= ( latDegreeOffset  ); // offset lat by n degrees (in )radians).
  lon -= ( latDegreeOffset ); // offset lon by n degrees (in )radians).
 //Spherical to cartesian coordinate conversion formula.
 //----      r (radius)              ----//
 //----      ? (theta) = lat    ----//
 //----      ? (phi) = lon     ----//
 
 //----      x = r sin ? cos ?       ----//
 //----      y = r sin ? sin ?       ----//
 //----      z = r cos ?             ----//
 
 var x  = radius * Math.sin( lat ) * Math.cos( lon );
 var y  = radius * Math.sin( lat ) * Math.sin( lon );
 var z  = radius * Math.cos( lat );
 // var x  = radius * Math.cos( lat ) * Math.cos( lon );
 // var y  = radius * Math.cos( lat ) * Math.sin( lon );
 // var z  = radius * Math.sin( lat );
 //Switch z and y (since z is forward) (see the right-hand rule).
 return [x, z, y];
};

function calc_position_2D(lat,lon,comp){

            var factor = comp.width/360;
            var x = (lon) * factor+ ( comp.width / 2);
            var y = (lat*-1) * factor + ( comp.height / 2);
return [x,y];
}

function degreesToRadians(deg){
var rad = deg * ( Math.PI /180);
return rad;
};

function build_ex_orient(lname){
var expr = new Array();
expr.push("lookAt(transform.position, thisComp.layer(\""+ lname+"\").transform.position);");
return expr.join("\n");
};
function build_ex_pos_3d(lname){
var expr = new Array();
expr.push("// build with locations.jsx");
expr.push("// apply to position");
expr.push("// taken from here");
expr.push("// http://bit.ly/RVZUUU");
expr.push("var lat = effect(\"lat\")(\"ADBE Angle Control-0001\") *-1;");
expr.push("var lon = effect(\"lon\")(\"ADBE Angle Control-0001\")*-1;");
expr.push("var radius = thisComp.layer(\""+ lname+"\").effect(\"radius\")(\"ADBE Slider Control-0001\");");
expr.push("var res = calc_rotation(lat,lon,radius);");
expr.push("var x = res[0] + thisComp.width/2;");
expr.push("var y = res[1] +thisComp.height/2;");
expr.push("var z = res[2] *-1;");
expr.push("[x,y,z]");
expr.push("function calc_rotation(lat, lon , radius){");
expr.push("    var latDegreeOffset = degreesToRadians(90) ;// in radians");
expr.push("    //Convert lat and lon to radians.");
expr.push("    lat = Math.PI * lat / 180;");
expr.push("    lon = Math.PI * lon / 180;");
expr.push("    // //Adjust lat and lon by radians.");
expr.push("     lat -= ( latDegreeOffset  ); // offset lat by n degrees (in )radians).");
expr.push("     lon -= ( latDegreeOffset ); // offset lon by n degrees (in )radians).");
expr.push("    //Spherical to cartesian coordinate conversion formula.");
expr.push("    //----      r (radius)              ----//");
expr.push("    //----      ? (theta) = lat    ----//");
expr.push("    //----      ? (phi) = lon     ----//");
expr.push("    ");
expr.push("    //----      x = r sin ? cos ?       ----//");
expr.push("    //----      y = r sin ? sin ?       ----//");
expr.push("    //----      z = r cos ?             ----//");
expr.push("    ");
expr.push("    var x  = radius * Math.sin( lat ) * Math.cos( lon );");
expr.push("    var y  = radius * Math.sin( lat ) * Math.sin( lon );");
expr.push("    var z  = radius * Math.cos( lat );");
expr.push("    // var x  = radius * Math.cos( lat ) * Math.cos( lon );");
expr.push("    // var y  = radius * Math.cos( lat ) * Math.sin( lon );");
expr.push("    // var z  = radius * Math.sin( lat );");
expr.push("    //Switch z and y (since z is forward) (see the right-hand rule).");
expr.push("    return [x, z, y];");
expr.push("}");

return expr.join("\n");
};

// ------------ end of script ------------
}